module RubocopAutomata
  module CI
    # For CircleCI
    module CircleCI
      module_function

      def repository_url
        "https://#{ENV['GITHUB_ACCESS_TOKEN']}@github.com/#{repository_name}"
      end

      def repository_name
        /^.+?github.com[:\/](?<repository_name>.+?)\.git$/.match(`git config --get remote.origin.url`)[:repository_name]
      end

      def base_branch
        ENV['CIRCLE_BRANCH']
      end

      def topic_branch
        "ci/auto_correction-#{ENV['CIRCLE_BUILD_NUM']}"
      end

      def pullrequest_title
        "rubocop --auto-correct at #{`echo -n $(date)`}"
      end

      def pullrequest_description
        <<~DESCRIPTION
          PR: #{ENV['CIRCLE_PULL_REQUEST']}
          Auto generated by [CircleCI](#{ENV['CIRCLE_BUILD_URL']})
        DESCRIPTION
      end
    end
  end
end
